@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

REM abFPCType=%1
REM abFPCCPUOS=%2
REM abFPCStartEXE=%3
REM abTARGETCPU=%4
REM abTARGETOS=%5
REM abFPCCrossEXE=%6
REM abParam=%7

IF '%1'=='' GOTO END_NOPAR
IF '%2'=='' GOTO END_NOPAR
IF '%3'=='' GOTO END_NOPAR
IF '%4'=='' GOTO END_NOPAR
IF '%5'=='' GOTO END_NOPAR
IF '%6'=='' GOTO END_NOPAR
IF '%7'=='' GOTO END_NOPAR

IF '%2'=='%4-%5' GOTO END_NOPAR

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@ INIT @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

if '%1'=='win32' SET path=C:\codetyphon\fpc\fpc32\bin\i386-win32;%path%
if '%1'=='win64' SET path=C:\codetyphon\fpc\fpc64\bin\x86_64-win64;%path%

if '%1'=='win64' (
SET abbits=64
SET abbincross=win64-%4-%5
) ELSE (
SET abbits=32
SET abbincross=win32-%4-%5
)



if NOT '%7'=='xxxx' (
SET abbincross=%abbincross%--%7
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@ Print Settings @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ECHO.
ECHO -----------------------------------------------
ECHO    FPC Cross Elements Engine settings
ECHO -----------------------------------------------
ECHO.
ECHO FPCType=%1
ECHO FPCCPUOS=%2
ECHO FPCStartEXE=%3
ECHO TARGETCPU=%4
ECHO TARGETOS=%5
ECHO FPCCrossEXE=%6
ECHO Param=%7
ECHO.
ECHO Bincross=%abbincross%
ECHO Bits=%abbits%


REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ MAIN @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ECHO.
ECHO =====================================================================
ECHO          %1 Build Cross for %4-%5 Param:%7
ECHO =====================================================================


if NOT EXIST ..\..\fpcsrc\Makefile.fpc (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   [ERROR]: FreePascal directory NOT Exists  
ECHO          sorry, build STOP 
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

if NOT EXIST ..\..\fpc\fpc%abbits%\bin\%2\make.exe (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   [ERROR]: Make.exe for %1 NOT Exists  
ECHO          sorry, build STOP 
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@ Toolschains @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

IF EXIST ..\..\Settings\CT_Cross_GNU_Toolschains_Engine_Enabled.ctsw (
START /B /WAIT x_FPC_Build_Binutils.bat %1 %2 %3 %4 %5 %6 %7
) ELSE (
ECHO.
ECHO [INFO]: Cross CT GNU Toolschains Engine Switch is OFF.
ECHO         Use files from GNU Toolschains Store.
ECHO.
)

IF EXIST ..\..\Settings\CT_Cross_FPC_Elements_Engine_Disabled.ctsw (
ECHO.
ECHO [INFO]: Cross CT FPC Elements Engine Switch is OFF.
ECHO         Cross Build procedure STOP. 
ECHO.
EXIT
)

if EXIST ..\..\fpc\newfpc (
ECHO [INFO]: Remove OLD FPC temporary build folder...
del /f/s/q ..\..\fpc\newfpc\ > nul
rmdir /s/q ..\..\fpc\newfpc\
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

IF EXIST ..\..\binToolchains\all-%4-%5 (
ECHO [INFO]: Copy Files from ToolsChains Library...
copy /Y ..\..\binToolchains\all-%4-%5\*.* C:\codetyphon\fpc\fpc%abbits%\bin\%2\
GOTO GO_STAGE0
) 

IF EXIST ..\..\binToolchains\%abbincross% (
ECHO [INFO]: Copy Files from ToolsChains Library...
copy /Y ..\..\binToolchains\%abbincross%\*.* C:\codetyphon\fpc\fpc%abbits%\bin\%2\

) ELSE (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   [ERROR]: Can NOT find Toolchain files for %abbincross% 
ECHO            in Toolchains Library.               
ECHO            sorry, Cross Build procedure STOP 
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:GO_STAGE0
ECHO. 
ECHO ----------------------------------------------------------------
ECHO       Stage 0: Clean FreePascal Directory
ECHO ----------------------------------------------------------------
ECHO.

START /D c:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\fpc%abbits%\bin\%2\make.exe clean
del /F /Q C:\codetyphon\fpcsrc\compiler\*.exe
del /F /Q C:\codetyphon\fpcsrc\compiler\utils\*.exe
del /F /Q c:\codetyphon\fpcsrc\utils\*.exe



REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
REM if the script find CUSTOM x_FPC_Build_Element_xxxx.bat will execute this script..

IF EXIST x_FPC_Build_Element_%4_%5_%7.bat (
START /B /WAIT x_FPC_Build_Element_%4_%5_%7.bat %1 %2 %3 %4 %5 %6 %7
GOTO GO_STAGE4
)

IF EXIST x_FPC_Build_Element_%4_%5.bat (
START /B /WAIT x_FPC_Build_Element_%4_%5.bat %1 %2 %3 %4 %5 %6 %7
GOTO GO_STAGE4
)

IF EXIST x_FPC_Build_Element_%4.bat (
START /B /WAIT x_FPC_Build_Element_%4.bat %1 %2 %3 %4 %5 %6 %7
GOTO GO_STAGE4
)

IF EXIST x_FPC_Build_Element_%5.bat (
START /B /WAIT x_FPC_Build_Element_%5.bat %1 %2 %3 %4 %5 %6 %7
GOTO GO_STAGE4
)

START /B /WAIT x_FPC_Build_Element.bat %1 %2 %3 %4 %5 %6 %7

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:GO_STAGE4
ECHO. 
ECHO ----------------------------------------------------------------
ECHO        Stage 4: Clean FreePascal Directory 
ECHO ----------------------------------------------------------------
ECHO.

START /D c:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\fpc%abbits%\bin\%2\make.exe clean
del /F /Q C:\codetyphon\fpcsrc\compiler\*.exe
del /F /Q C:\codetyphon\fpcsrc\compiler\utils\*.exe
del /F /Q c:\codetyphon\fpcsrc\utils\*.exe

ECHO.
ECHO ----------------------------------------------------------------
ECHO        Stage 5: Copy Files and Units
ECHO ----------------------------------------------------------------
ECHO.

mkdir ..\..\fpc\fpc%abbits%
xcopy /E /R /Y /Q ..\..\fpc\newfpc\*.* ..\..\fpc\fpc%abbits%\

if EXIST ..\..\fpc\newfpc (
ECHO.
ECHO [INFO]: Remove FPC temporary build folder...
del /f/s/q ..\..\fpc\newfpc\ > nul
rmdir /s/q ..\..\fpc\newfpc\
)

REM ------------------------- Check------------------------------------

if EXIST C:\codetyphon\fpc\fpc%abbits%\units\%4-%5\rtl\system.ppu GOTO GO_ALL_OK

ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO  [ERROR]: %1 Cross Element for %4-%5 Param:%7 NOT Exists 
ECHO         sorry, Cross Build procedure STOP
ECHO ???????????????????????????????????????????????????????????
ECHO.

EXIT
REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:GO_ALL_OK

if EXIST ..\..\allzips\bingdb\gdb-win%abbits%-%4-%5.7z (
..\..\binBase\%2\7zr.exe x ..\..\allzips\bingdb\gdb-win%abbits%-%4-%5.7z -o..\..\binGDB\ -y
)

ECHO.
ECHO [FINAL INFO]: -- !!! %1 %4-%5 Param:%7 Cross Build Element Build OK !!! --
ECHO.
EXIT

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:END_NOPAR

ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     [ERROR]:  Sorry NO Script Parameters. 
ECHO ???????????????????????????????????????????????????????????
ECHO.

EXIT

