@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

title CodeTyphon Build FreePascal 64bit

SET path=C:\codetyphon\fpc\fpc64\bin\x86_64-win64;%path%

REM ----------- Check for Bitness------------------
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )  
REM -----------------------------------------------

if %_Bitness% == 32 (
ECHO.
ECHO [INFO]: Skip 64bit actions, this is 32 bits system... 
ECHO.
EXIT
)
REM -----------------------------------------------

ECHO.
ECHO =====================================================================
ECHO                  Build FreePascal 64bit  
ECHO =====================================================================


if NOT EXIST ..\fpcsrc\Makefile.fpc (
ECHO [INFO]: FPC64 Source files not exists, extracting...
START /B /WAIT x_FPC_Extract_Source_From_ZipFile
)

if NOT EXIST ..\fpc\fpc64\bin\x86_64-win64\make.exe (
ECHO [INFO]: FPC64 Binary files not exists, extracting...
START /B /WAIT x_FPC_Install_Bin_Files 64
)

if EXIST ..\fpc\newfpc (
ECHO [INFO]: Remove OLD FPC temporary build folder...
del /f/s/q ..\fpc\newfpc\ > nul
rmdir /s/q ..\fpc\newfpc\
)

ECHO.
ECHO -------------------------------------------------------
ECHO                  Clean FreePascal 64bit 
ECHO -------------------------------------------------------
START /D ..\fpcsrc\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe clean

ECHO.
ECHO -------------------------------------------------------
ECHO                  Build FreePascal 64bit 
ECHO -------------------------------------------------------
START /D ..\fpcsrc\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all

REM ===============================================================================
IF EXIST ..\Settings\CT_FPC_Stop_Before_Install.ctsw (
ECHO.
ECHO [INFO]: Switch, FPC Stop Before Install Procedure, is ON.
ECHO         FPC Build procedure STOP. 
ECHO.
EXIT
)
REM ===============================================================================

ECHO.
ECHO -------------------------------------------------------
ECHO                  Install FreePascal 64bit 
ECHO -------------------------------------------------------
START /D ..\fpcsrc\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe install INSTALL_PREFIX=C:/codetyphon/fpc/newfpc

ECHO.
ECHO -------------------------------------------------------
ECHO                  Clean FreePascal 64bit 
ECHO -------------------------------------------------------
START /D ..\fpcsrc\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe clean
ECHO.
ECHO [INFO]: Clean finish...

REM ------------------------- COPY FILES-------------------------------

ECHO.
ECHO -------------------------------------------------------
ECHO                  Copy FreePascal 64bit 
ECHO -------------------------------------------------------

if NOT EXIST ..\fpc\fpc64 (
mkdir ..\fpc\fpc64
)
xcopy /E /R /Y /Q ..\fpc\newfpc\*.* ..\fpc\fpc64\

if EXIST ..\fpc\newfpc (
ECHO.
ECHO [INFO]: Remove FPC temporary build folder...
del /f/s/q ..\fpc\newfpc\ > nul
rmdir /s/q ..\fpc\newfpc\
)

ECHO.
ECHO [FINAL INFO]: FreePascal 64 Building, finish...
ECHO.

exit
