@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

title CodeTyphon Build Typhon Small-IDE for Win64

SET path=C:\codetyphon\fpc\fpc64\bin\x86_64-win64;%path%

REM ----------- Check for Bitness------------------
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )  
REM -----------------------------------------------

if %_Bitness% == 32 (
ECHO.
ECHO [INFO]: Skip 64bit actions, this is 32 bits system... 
ECHO.
EXIT
)
REM -----------------------------------------------

ECHO.
ECHO =====================================================================
ECHO             Build Typhon64 Small-IDE for Win64
ECHO =====================================================================
ECHO.

if NOT EXIST ..\fpc\fpc64\units\x86_64-win64\rtl\classes.o (
ECHO [INFO]: FreePascal Units for Win64 NOT EXIST !!!
START /B /WAIT x_FPC_Win64_Build.bat
)

if NOT EXIST ..\typhon\Makefile.fpc (
ECHO [INFO]: Typhon Source NOT EXIST !!!
START /B /WAIT x_Typhon_Exract_Source_from_ZipFile
)

ECHO.
ECHO -------------------------------------------------------
ECHO                  Prepare Typhon64 Win64 
ECHO -------------------------------------------------------
ECHO.

IF NOT EXIST ..\typhon\bin64\ (
mkdir ..\typhon\bin64
ECHO [INFO]: create ..\typhon\bin64 directory
)

IF EXIST ..\typhon\bin64\styphon.exe (
del /F /Q ..\typhon\bin64\styphon.exe
)

if EXIST ..\typhon\bin64\CT_Is_BigIDE.ctsw (
 del /F /Q ..\typhon\bin64\CT_Is_BigIDE.ctsw
)

START /B /WAIT x_Typhon_Settings_Restore.bat

ECHO.
ECHO -------------------------------------------------------
ECHO                  Compile Typhon64 Win64 
ECHO -------------------------------------------------------
ECHO.

if EXIST ..\Settings\CT_Use_GTK2.ctsw (
 START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all LCL_PLATFORM=gtk2 OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\  
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_GTK3.ctsw (
 START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all LCL_PLATFORM=gtk3 OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\  
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_QT4.ctsw (
 START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all LCL_PLATFORM=qt OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\  
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_QT5.ctsw (
 START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all LCL_PLATFORM=qt5 OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\  
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_CustomDrawn.ctsw (
 START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all LCL_PLATFORM=customdrawn OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\  
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_fpGUI.ctsw (
 START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all LCL_PLATFORM=fpgui OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\  
 GOTO ENDBUILD
)

START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe all OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\

REM @@@@@@@@@@@@@@@@@@@@@@@@ ENDBUILD @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:ENDBUILD

ECHO.
ECHO =======================================================
IF NOT EXIST ..\typhonTemp\ (
mkdir ..\typhonTemp
ECHO.
ECHO [INFO]: create ..\typhonTemp directory.
)

IF EXIST ..\typhon\typhon.exe (
ECHO.
ECHO [INFO]: Move Executables

move /Y ..\typhon\*.exe ..\typhon\bin64\
move /Y ..\typhon\tools\*.exe ..\typhon\bin64\

ECHO.
ECHO [INFO]: Clean Tools Directory

del /F /Q /S ..\typhon\tools\*.o
del /F /Q /S ..\typhon\tools\*.ppu

ECHO.

START /B /WAIT x_Typhon_Strip 64
START /B /WAIT xx_CodeTyphon_Make_Links

ECHO.
ECHO [FINAL INFO]: Typhon64 Small-IDE Build OK !!!.

) ELSE (
ECHO.
ECHO ??????????????????????????????????????????????????????
ECHO [ERROR]: Typhon64 Small-IDE IDE NOT Build
ECHO ??????????????????????????????????????????????????????
)

EXIT
